// CheckDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Check.h"
#include "CheckDlg.h"

#include <stdio.h>
#include <stdlib.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCheckDlg dialog

CCheckDlg::CCheckDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCheckDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCheckDlg)
	m_RichEditMessage = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCheckDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCheckDlg)
	DDX_Text(pDX, IDC_RICHEDIT_INFORMATION_BOX, m_RichEditMessage);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCheckDlg, CDialog)
	//{{AFX_MSG_MAP(CCheckDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_START_CHOOSESOURCEFOLDER, OnStartChooseSourceFolder)
	ON_BN_CLICKED(IDC_BUTTON_WRITE_REPORT, OnButtonWriteReport)
	ON_COMMAND(ID_START_CHOOSEDESTINATIONFOLDER, OnStartChooseDestinationFolder)
	ON_BN_CLICKED(IDC_BUTTON_CHECK_ARCHIVE, OnButtonCheckArchive)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCheckDlg message handlers

BOOL CCheckDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCheckDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCheckDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCheckDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
///++++++++++     ,       ++++++
///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++

///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
///++++++++++               ++++++++++++
///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++

CString sPathDestination, sPathSource;
CFile hLogFile;		//  ,   

int FlagInit = 0;		//      
CFile hReportFile;	//    
 
int CurrentPosition = 0; //    
DWORD dwTotalCheckSum = 0;

///++++++++++++++++++    ++++++++++++++++++++

//++++++++++  +++++++++++++++++++++++
void CCheckDlg::OnStartChooseDestinationFolder()  //      
{
	//          
	sPathDestination = ChooseFolder();
	m_RichEditMessage+="\n  : ";
	m_RichEditMessage+=sPathDestination;
	UpdateData(FALSE);
}

void CCheckDlg::OnStartChooseSourceFolder()  //      
{
	//         -
 	sPathSource = ChooseFolder();
	m_RichEditMessage+="\n-: ";
	m_RichEditMessage+=sPathSource;
	UpdateData(FALSE);
}
//++++++++++++  +++++++++++++++++++++++++
CString CCheckDlg::ChooseFolder()   // ,   
{
	//        ,   
	TCHAR path[MAX_PATH*4];  //       
    BROWSEINFO lpbi;
    ITEMIDLIST *Id;
	
    lpbi.hwndOwner = 0;		//   BROWSEINFO
    lpbi.pidlRoot = NULL;
    lpbi.pszDisplayName = path;
    lpbi.lpszTitle  = _T(" ");
    lpbi.ulFlags = NULL; // BIF_BROWSEINCLUDEFILES; //   
    lpbi.lpfn = NULL;
    lpbi.lParam = NULL;
    lpbi.iImage = NULL;
	
    Id = SHBrowseForFolder(&lpbi);
    if(Id)	{
        SHGetPathFromIDList(Id, path);
    }
	return path;
}

//+++++++++++++++++ +++++++++++++++++++++++++++++++++
void CCheckDlg::OnButtonWriteReport()   //    
{
	//     
	char buf[20];
	CTime theTime = CTime::GetCurrentTime();  //    

	BrowseAndCalculateCheckSum(sPathSource);
	m_RichEditMessage+="\n  report.bin  LogFile.txt  " + theTime.Format("%x  %X") +",   : <";;
	sprintf(buf,"%X", dwTotalCheckSum);
	m_RichEditMessage+=buf;
	m_RichEditMessage+=">";
	UpdateData(FALSE);
	
	CreateLogFile(m_RichEditMessage);
}

	
void CCheckDlg::OnButtonCheckArchive() //   
{
	//     	
	char buf[20];
	CTime theTime = CTime::GetCurrentTime();  //    
		
	BrowseAndCompareCheckSum(sPathSource);
	m_RichEditMessage+="\n   "+ theTime.Format("%x  %X") +",  : <";	
	sprintf(buf,"%X", dwTotalCheckSum);
	m_RichEditMessage+=buf;
	m_RichEditMessage+=">";

	UpdateData(FALSE);

	CreateLogFile(m_RichEditMessage);
}
//++++++++++++++++ ++++++++++++++++++++++++++++++++++++
//   
void CCheckDlg::CreateLogFile(CString LogMessage)
{
	CStdioFile hLogFile;
	hLogFile.Open(sPathDestination+"\\LogFile.txt", CFile::modeCreate | CFile::modeWrite );
	hLogFile.WriteString(LogMessage.GetBuffer(0));
    hLogFile.Close();
}


//++++++++++++++++     :++++++++++++++++++++++++++++++++++++++++

//++++++++++++++++++++++++++++++++++++++++++++++++++
int CCheckDlg::BrowseAndCalculateCheckSum(CString RootPath)   //      .       
{
	CString NextRoot = RootPath;
	CString ComprString;	
	int dwCheckSum = 0;
	short int PathLength;
	
	if(FlagInit==0) 	// to maintain file.open procedure
	{
        FlagInit++; 
		hReportFile.Open(sPathDestination + "\\report.bin", CFile::modeCreate | CFile::modeWrite );		
	}else
		FlagInit++;
	
	HANDLE hFindFile;			/// this block is getting files and folders from a folder
	WIN32_FIND_DATA fd;
	
	hFindFile=FindFirstFile(NextRoot + "\\*", &fd);    /// Looking for a first file  should check if it is a file or a folder

	while (FindNextFile(hFindFile, &fd))     //looking for the rest files
	{	
		ComprString = fd.cFileName;

		if ((FILE_ATTRIBUTE_DIRECTORY & fd.dwFileAttributes)&&(("." != ComprString)&&(".." != ComprString)))// ,   ,    
					BrowseAndCalculateCheckSum(NextRoot+"\\"+ComprString);

		else 
			if (!(FILE_ATTRIBUTE_DIRECTORY & fd.dwFileAttributes))	 {   //   
				char pBufFilePath[MAX_PATH];    
				CString cFullPath;
			
				cFullPath = NextRoot + "\\"; //     - 
				cFullPath += fd.cFileName;
				cFullPath.Replace(sPathSource, NULL); //    			
				sprintf(pBufFilePath,"%s", cFullPath);  //   
				//sprintf(pBufFilePath,"%s", fd.cFileName);//    
			
				PathLength = 0; //  ,        ,   - pBufFilePath[]  -
				for(int i=0;i<MAX_PATH;i++)	{
					if (pBufFilePath[i] != 0)
						PathLength++;
					else	{
						PathLength++;
						break;
					}
				}			
				
				if ((ComprString != "report.bin")&&(ComprString != "LogFile.txt")) {	//         report.bin  LogFile.txt
				
					hReportFile.Write(pBufFilePath, PathLength);//         (with null-terminator)
			
					dwCheckSum = CalculateCheckSum(NextRoot + "\\" + ComprString);   // call for this function to calculate check summ for the file		
					dwTotalCheckSum+=dwCheckSum;
					hReportFile.Write(&dwCheckSum, 4);
				}
			}		
	}		

	FlagInit--; 		// to close report file before exit 
	if(FlagInit==0)
	{        
		hReportFile.Close();
	}
	return 0;
}





//---------------------------------------------
DWORD CCheckDlg::CalculateCheckSum(CString path)     //    CRC      ,   -   CRC
{
	DWORD CRC_Sum;
	
	if ((0 == path.Replace("\\report.bin",NULL))
		&&(0 == path.Replace("\\LogFile.txt",NULL)) )    /// ,     
		CRC_Sum = CRC(path);
	else 
		CRC_Sum = 0;

	return CRC_Sum;
}

//----------------------------------------------
//   9 -     
int CCheckDlg::BrowseAndCompareCheckSum(CString RootPath)   //       
{
	CString NextRoot = RootPath;
	CString ComprString;	
	DWORD dwCheckSum = 0, dwCheckSumFromReport;
	CString cFileNameFromReport, cFileNameOnCurrentCheck;
	int PathLength;
	
	if(FlagInit==0) 	//   /  report.bin file.open procedure
	{
        FlagInit++; 
		if (!hReportFile.Open(RootPath + "\\report.bin", CFile::modeRead))	{
			m_RichEditMessage+="\n    :    ";
			return 9;
		}
		dwTotalCheckSum = 0;
		CurrentPosition=0;
	}else
		FlagInit++;
	
	/// this block is getting files and folders from a folder
	HANDLE hFindFile;
	WIN32_FIND_DATA fd;
	
	hFindFile=FindFirstFile(NextRoot + "\\*", &fd);    /// Looking for a first file  should check if it is a file or a folder
	// -    ".." -     ,       -    
	while (FindNextFile(hFindFile, &fd))     //looking for the rest files
	{	
		ComprString = fd.cFileName;

		if ((FILE_ATTRIBUTE_DIRECTORY & fd.dwFileAttributes)&&(("." != ComprString)&&(".." != ComprString)))// ,   ,    
					BrowseAndCompareCheckSum(NextRoot+"\\"+ComprString);
		else 
			if ((!(FILE_ATTRIBUTE_DIRECTORY & fd.dwFileAttributes))&&(ComprString != "LogFile.txt")&&(ComprString != "report.bin")    //       
								&&(("." != ComprString)&&(".." != ComprString)))	 {   //   
	 //++++++++++++++++++        
				char pbuf[(MAX_PATH)+4];  // the maximum file name 
				char buf[4]; // CheckSum

				hReportFile.Read(pbuf, (MAX_PATH)); // ,   
		
				PathLength = 0;					//  ,    pbuf[]  -
				for(int i=0;i<MAX_PATH;i++)	{
					if (pbuf[i] != 0)	{
						PathLength++;
						//cFileNameFromReport+=pbuf[i]; //      
						//m_RichEditMessage+=pbuf[i];   // for debugging needs
					}
					else {
						PathLength++;
						break;
					}
				}
				cFileNameFromReport = pbuf;//      
				cFileNameOnCurrentCheck = NextRoot + "\\" + ComprString; //   
				cFileNameOnCurrentCheck.Replace(sPathSource, NULL);

				CurrentPosition += PathLength;		
				hReportFile.Seek(CurrentPosition,CFile::begin);	//       mooving file pointer to the position we need
				hReportFile.Read(buf, 4);  //,    
				CurrentPosition += 4; //       
		
				DWORD *IntNum;		///  
				IntNum=(DWORD*)buf;  //   

				dwCheckSumFromReport = *IntNum;
       // ++++++++++++++++++++++++
				
				char useItForOutput[20];											//debugging stuff
				/*
				sprintf(useItForOutput,"%X",dwCheckSumFromReport);
				m_RichEditMessage+="  "+NextRoot + "\\" + ComprString +": ";	
				m_RichEditMessage+=useItForOutput;*/
				
				if (cFileNameOnCurrentCheck == cFileNameFromReport )     { //      
					dwCheckSum = CalculateCheckSum(NextRoot + "\\" + ComprString);// call for this function to calculate check summ for the file
					dwTotalCheckSum+=dwCheckSum;
																				  /*
				sprintf(useItForOutput,"%X",dwCheckSum);
				m_RichEditMessage+="\t";
				m_RichEditMessage+=useItForOutput;
				m_RichEditMessage+="\n"; 	*/	
				
					if (dwCheckSum != dwCheckSumFromReport)	{          //     
					
					
					m_RichEditMessage+="\n\n! ****** !   : "+NextRoot + "\\" + ComprString+" : ****** !\n";
					sprintf(useItForOutput,"%X",dwCheckSumFromReport);
					m_RichEditMessage+="  "+NextRoot + "\\" + ComprString +": : <";	
					m_RichEditMessage+=useItForOutput;
		
				
					sprintf(useItForOutput,"%X",dwCheckSum);
					m_RichEditMessage+=">\t: <";
					m_RichEditMessage+=useItForOutput;
					m_RichEditMessage+=">\n! **************** !\n";
					}
				}
				else {
					m_RichEditMessage+="\n      :"+cFileNameFromReport+" v.s. "+cFileNameOnCurrentCheck;
				}
			}		
	}		

	FlagInit--; 	// to close report file before exit 
	if(FlagInit==0)
	{        
		hReportFile.Close();
	}
	return 0;
}

//        
DWORD CCheckDlg::CRC(CString path)
{
	typedef unsigned char  uchar; /*  8 bits or more */
	
#define CRC_MASK    0xFFFFFFFFUL
#define UPDATE_CRC(crc, c)  \
    crc = crctable[(uchar)crc ^ (uchar)(c)] ^ (crc >> 8)
	DWORD  crctable[256]= {/*CRC 0xedb88320 */
		0x00000000l, 0x77073096l, 0xee0e612cl, 0x990951bal, 0x076dc419l, 0x706af48fl, 0xe963a535l, 0x9e6495a3l,
		0x0edb8832l, 0x79dcb8a4l, 0xe0d5e91el, 0x97d2d988l, 0x09b64c2bl, 0x7eb17cbdl, 0xe7b82d07l, 0x90bf1d91l,
		0x1db71064l, 0x6ab020f2l, 0xf3b97148l, 0x84be41del, 0x1adad47dl, 0x6ddde4ebl, 0xf4d4b551l, 0x83d385c7l,
		0x136c9856l, 0x646ba8c0l, 0xfd62f97al, 0x8a65c9ecl, 0x14015c4fl, 0x63066cd9l, 0xfa0f3d63l, 0x8d080df5l,
		0x3b6e20c8l, 0x4c69105el, 0xd56041e4l, 0xa2677172l, 0x3c03e4d1l, 0x4b04d447l, 0xd20d85fdl, 0xa50ab56bl,
		0x35b5a8fal, 0x42b2986cl, 0xdbbbc9d6l, 0xacbcf940l, 0x32d86ce3l, 0x45df5c75l, 0xdcd60dcfl, 0xabd13d59l,
		0x26d930acl, 0x51de003al, 0xc8d75180l, 0xbfd06116l, 0x21b4f4b5l, 0x56b3c423l, 0xcfba9599l, 0xb8bda50fl,
		0x2802b89el, 0x5f058808l, 0xc60cd9b2l, 0xb10be924l, 0x2f6f7c87l, 0x58684c11l, 0xc1611dabl, 0xb6662d3dl,
		0x76dc4190l, 0x01db7106l, 0x98d220bcl, 0xefd5102al, 0x71b18589l, 0x06b6b51fl, 0x9fbfe4a5l, 0xe8b8d433l,
		0x7807c9a2l, 0x0f00f934l, 0x9609a88el, 0xe10e9818l, 0x7f6a0dbbl, 0x086d3d2dl, 0x91646c97l, 0xe6635c01l,
		0x6b6b51f4l, 0x1c6c6162l, 0x856530d8l, 0xf262004el, 0x6c0695edl, 0x1b01a57bl, 0x8208f4c1l, 0xf50fc457l,
		0x65b0d9c6l, 0x12b7e950l, 0x8bbeb8eal, 0xfcb9887cl, 0x62dd1ddfl, 0x15da2d49l, 0x8cd37cf3l, 0xfbd44c65l,
		0x4db26158l, 0x3ab551cel, 0xa3bc0074l, 0xd4bb30e2l, 0x4adfa541l, 0x3dd895d7l, 0xa4d1c46dl, 0xd3d6f4fbl,
		0x4369e96al, 0x346ed9fcl, 0xad678846l, 0xda60b8d0l, 0x44042d73l, 0x33031de5l, 0xaa0a4c5fl, 0xdd0d7cc9l,
		0x5005713cl, 0x270241aal, 0xbe0b1010l, 0xc90c2086l, 0x5768b525l, 0x206f85b3l, 0xb966d409l, 0xce61e49fl,
		0x5edef90el, 0x29d9c998l, 0xb0d09822l, 0xc7d7a8b4l, 0x59b33d17l, 0x2eb40d81l, 0xb7bd5c3bl, 0xc0ba6cadl,
		0xedb88320l, 0x9abfb3b6l, 0x03b6e20cl, 0x74b1d29al, 0xead54739l, 0x9dd277afl, 0x04db2615l, 0x73dc1683l,
		0xe3630b12l, 0x94643b84l, 0x0d6d6a3el, 0x7a6a5aa8l, 0xe40ecf0bl, 0x9309ff9dl, 0x0a00ae27l, 0x7d079eb1l,
		0xf00f9344l, 0x8708a3d2l, 0x1e01f268l, 0x6906c2fel, 0xf762575dl, 0x806567cbl, 0x196c3671l, 0x6e6b06e7l,
		0xfed41b76l, 0x89d32be0l, 0x10da7a5al, 0x67dd4accl, 0xf9b9df6fl, 0x8ebeeff9l, 0x17b7be43l, 0x60b08ed5l,
		0xd6d6a3e8l, 0xa1d1937el, 0x38d8c2c4l, 0x4fdff252l, 0xd1bb67f1l, 0xa6bc5767l, 0x3fb506ddl, 0x48b2364bl,
		0xd80d2bdal, 0xaf0a1b4cl, 0x36034af6l, 0x41047a60l, 0xdf60efc3l, 0xa867df55l, 0x316e8eefl, 0x4669be79l,
		0xcb61b38cl, 0xbc66831al, 0x256fd2a0l, 0x5268e236l, 0xcc0c7795l, 0xbb0b4703l, 0x220216b9l, 0x5505262fl,
		0xc5ba3bbel, 0xb2bd0b28l, 0x2bb45a92l, 0x5cb36a04l, 0xc2d7ffa7l, 0xb5d0cf31l, 0x2cd99e8bl, 0x5bdeae1dl,
		0x9b64c2b0l, 0xec63f226l, 0x756aa39cl, 0x026d930al, 0x9c0906a9l, 0xeb0e363fl, 0x72076785l, 0x05005713l,
		0x95bf4a82l, 0xe2b87a14l, 0x7bb12bael, 0x0cb61b38l, 0x92d28e9bl, 0xe5d5be0dl, 0x7cdcefb7l, 0x0bdbdf21l,
		0x86d3d2d4l, 0xf1d4e242l, 0x68ddb3f8l, 0x1fda836el, 0x81be16cdl, 0xf6b9265bl, 0x6fb077e1l, 0x18b74777l,
		0x88085ae6l, 0xff0f6a70l, 0x66063bcal, 0x11010b5cl, 0x8f659effl, 0xf862ae69l, 0x616bffd3l, 0x166ccf45l,
		0xa00ae278l, 0xd70dd2eel, 0x4e048354l, 0x3903b3c2l, 0xa7672661l, 0xd06016f7l, 0x4969474dl, 0x3e6e77dbl,
		0xaed16a4al, 0xd9d65adcl, 0x40df0b66l, 0x37d83bf0l, 0xa9bcae53l, 0xdebb9ec5l, 0x47b2cf7fl, 0x30b5ffe9l,
		0xbdbdf21cl, 0xcabac28al, 0x53b39330l, 0x24b4a3a6l, 0xbad03605l, 0xcdd70693l, 0x54de5729l, 0x23d967bfl,
		0xb3667a2el, 0xc4614ab8l, 0x5d681b02l, 0x2a6f2b94l, 0xb40bbe37l, 0xc30c8ea1l, 0x5a05df1bl, 0x2d02ef8dl
	};	
	
	DWORD   crc;
	FILE   *fp;
	
#define BUFFERSIZE  1024
#define CRCPOLY     0xEDB88320UL
	/* 1110 1101 1001 1000 1000 0011 0010 0000 */
	
	size_t len;
	char *buffer, *sav;
	
	
	if ( ( fp = fopen(path, "rb" ) ) == NULL ) return 0;
	
    crc = CRC_MASK;
    buffer = (char *) calloc( BUFFERSIZE,1 );
	sav = buffer;
	while ( ( len = fread(buffer,1,BUFFERSIZE,fp) ) > 0 ) {
		while ( len-- ) UPDATE_CRC( crc, *buffer++ );
		buffer = sav;
	}
	free(buffer);
	len = (unsigned int)(crc>>16);  //   
	//printf( "File = %13s CRC32 = %04x %04x\n", path, (int)~len, (int)~crc );
	
	fclose( fp );
	flushall();
	return (int)~crc;
}





//*****************************************************************************
//*************       ,       **********************
//*****************************************************************************
